unit ModTape;

interface uses sysutils;

type

     TapeData=record
               typ:String[15];
               name:String[10];
               code:String[4];
               Real,Data:record start,ends:longint; end;
              end;

     TTapeInfo=class
               private
                fbuffer:Array[0..$4000] of byte;
                fTapelist:array[0..100] of tapeData;
                fcalc_checksum:Byte;
                fCount: Byte;
                tap_file_open: Boolean;
                ftapname:String;
                fhandle:File;

                procedure SetTape(FName:String);
                function GetData(index:Byte):TapeData;
                procedure CloseTape;

                procedure Skip_block(length_wanted:Word);
                procedure Read_block(start_ix, length_wanted:Word);
               public
                 function TAP_load(id_a:Byte; start_ix, length_de:Word):Byte;
                 property tapename: String read fTapName write SetTape;
                 property Count:Byte read fCount;
                 property List[index:Byte]: TapeData read Getdata;
                 property Handle: File read FHandle;
               end;

var Tape: TTapeinfo;

implementation uses ModMain,ModZ80;

procedure TTapeInfo.skip_block(length_wanted:Word);
var i,anz_gelesen:integer;
begin
 blockread(fhandle,fbuffer,length_wanted,anz_gelesen);
 for i:=0 to anz_gelesen-1 do fcalc_checksum:=fcalc_checksum xor fbuffer[i];
end;

procedure TTapeInfo.read_block(start_ix, length_wanted:Word);
var anz_gelesen,i:integer;
begin
        blockread(fhandle,fbuffer,length_wanted,anz_gelesen);
	for i:=0 to anz_gelesen-1 do
	begin
	 pokeb(start_ix,fbuffer[i]);
	 fcalc_checksum:=fcalc_checksum xor fbuffer[i];
	 inc(start_ix);
	end;
end;

function TTapeInfo.TAP_load(id_a:Byte; start_ix, length_de:Word):Byte;
var length:pair;
    id_tape, checksum:Byte;
begin
	if (TAP_file_open=false) then
         begin tap_load:=0;exit;end;(* fail, no file *)

	if eof(fhandle) then seek(fhandle,0); (* Back to start *)
	blockread(fhandle,length.l,1);
	blockread(fhandle,length.h,1);

	dec(length.W,2); (* Now actual Spectrum length *)

        blockread(fhandle,id_tape,1);
	fcalc_checksum:=id_tape;

	if id_tape=id_a then (* Yes, the correct ID, proceed. *)
	begin
		if(length_de<=length.W) then (* Length <= so OK *)
		begin
			read_block(start_ix,length_de);
			if length_de<>length.W then
				skip_block(length.W-length_de);
                        blockread(fhandle,checksum,1);
			inc(ix.w,length_de);
			de.w:=0; (* checksum in this case? *)
			if checksum=fcalc_checksum then
				tap_load:=1  (* success *)
			   else tap_load:=0; (* fail *)
		end
		else (* Too many bytes requested *)
		begin
			read_block(start_ix,length.W);
                        blockread(fhandle,checksum,1);
			inc(ix.w,length.W);
			DE.w:=0;
			tap_load:=0; (* fail *)
		end;
	end
	else (* Wrong ID! *)
	begin
		skip_block(length.W);
                blockread(fhandle,checksum,1);
		tap_load:=0; (* fail *)
	end;
end;

procedure TTapeInfo.CloseTape;
begin
  if tap_file_open then
   begin
    close(fhandle);tap_file_open:=false;
   end;
end;

procedure TTapeInfo.SetTape(FName:String);
var j,i,tapfile:byte;
    Temp:Array[1..10] of byte;
    len:word;
    counter:longint;
begin
 ftapname:=fName;
 counter:=0;fCount:=0;len:=0;tap_file_open:=false;
 if tap_file_open then close(fhandle);

 if not fileexists(fname) then exit;
 if pos('.TAP',uppercase(fname))>0 then tapfile:=2 else tapfile:=0;

 assignfile(fhandle,fname);
 filemode:=0;
 reset(fhandle,1);

 while not eof(fhandle) do
  with ftapelist[fcount] do
  begin
    fillchar(ftapelist[fcount],sizeof(ttapeinfo),0);

    blockread(fhandle,temp,2);
    real.start:=counter;inc(counter,2);
    len:=temp[1]+temp[2] shl 8 - word(tapfile);
    real.ends:=len;

    blockread(fhandle,temp,1);
    inc(counter,len+2);
    if (temp[1]=0) and (len=17) then
    begin
     blockread(fhandle,temp,1);
     case temp[1] of
      3:typ:='Bytes';
      1:typ:='Number array';
      2:typ:='Character array';
      0:typ:='Program';
     end;

     if temp[1]<4 then
      begin
       j:=temp[1];
       blockread(fhandle,temp,10);
       name:='';
       for i:=1 to 10 do name:=name+chr(temp[i]);
       case j of
        0:begin
           blockread(fhandle,temp,4);
           i:=temp[4] and $c0;
           if i=0 then
             begin
              code:='LINE';
              data.start:=temp[3]+word(temp[4]) shl 8;
             end;
            end;
         3:begin
            blockread(fhandle,temp,4);
            code:='CODE';
            data.start:=temp[3]+word(temp[4]) shl 8;
            data.ends:=temp[1]+word(temp[2]) shl 8;
           end;
         end;
        end;
  end;
  seek(fhandle,counter);
  inc(fcount);
 end;
 close(fhandle);

 assignfile(fhandle,fName);
 filemode:=0;
 reset(fhandle,1);
 tap_file_open:=true;
end;

function TTapeInfo.GetData(index:Byte):TapeData;
begin
 if index>fcount then index:=fcount;
 result:=ftapelist[index];
end;

end.
