unit UAbout;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ShellApi;

type
  TfrmAbout = class(TForm)
    btnOK: TButton;
    Timer1: TTimer;
    pnlAbout: TPanel;
    ScrollBox: TScrollBox;
    Label1: TLabel;
    lblFree: TLabel;
    lblAuthorEmail: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    bvAbout: TBevel;
    Label6: TLabel;
    lblRunningon: TLabel;
    Label3: TLabel;
    Image1: TImage;
    lblName: TLabel;
    lblVersion: TLabel;
    lblSysinfo: TLabel;
    procedure btnOKClick(Sender: TObject);
    procedure lblUrlClick(Sender: TObject);
    procedure lblAuthorEmailClick(Sender: TObject);
    procedure lblHyper64Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure OpenObject(sObjectPath : PChar);
  public
    { Public declarations }
  end;

var
  frmAbout: TfrmAbout;

implementation uses Registry;

{$R *.DFM}
function isNT:Boolean;
asm
        MOV     EAX, fs:[30h]
        TEST    EAX, EAX
        JS      @is9x

  @isNT:
        mov result, true
        jmp @ende
  @is9x:
        mov result, false
  @ende:
end;
function GetCPUSpeed: Double;
const
  DelayTime = 500;
var
  TimerHi, TimerLo: DWORD;
  PriorityClass, Priority: Integer;
begin
  PriorityClass := GetPriorityClass(GetCurrentProcess);
  Priority := GetThreadPriority(GetCurrentThread);

  SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);

  Sleep(10);
  asm
    dw 310Fh
    mov TimerLo, eax
    mov TimerHi, edx
  end;
  Sleep(DelayTime);
  asm
    dw 310Fh
    sub eax, TimerLo
    sbb edx, TimerHi
    mov TimerLo, eax
    mov TimerHi, edx
  end;

  SetThreadPriority(GetCurrentThread, Priority);
  SetPriorityClass(GetCurrentProcess, PriorityClass);

  Result := TimerLo / (1000.0 * DelayTime);
end;

function GetCpu(value: integer): string;
var
  SI : TSystemInfo;
begin
  Result:='(unavailable)';
  with TRegistry.create do begin
   try
    RootKey := HKEY_LOCAL_MACHINE;
    LazyWrite := false;
    OpenKey('Hardware\Description\System\CentralProcessor\0', False);
    case value of
     1: if ReadString('Identifier')<>'' then         Result:= ReadString('Identifier');
     2: if ReadString('VendorIdentifier')<>'' then   Result:= ReadString('VendorIdentifier');
    end;
    CloseKey;
   finally
    Free;
   end;
  end;
  GetSystemInfo(SI);
  case value of
   3: result:= Format('%f MHz', [GetCPUSpeed]);
   4: result:= IntToStr(SI.dwNumberOfProcessors);
   5: result:= IntToStr(SI.dwActiveProcessorMask);
   6: result := IntToStr(SI.wProcessorRevision);
  end;
end;
function GetMemoryStatus(Mode : Byte) : string;
var
  MemInfo : TMemoryStatus;
  r:Longint;
begin
  MemInfo.dwLength := Sizeof (MemInfo);
  GlobalMemoryStatus(MemInfo);
  r:=0;
  with MemInfo do
    case Mode of
      0 : r := dwTotalPhys div 1024;
      1 : r := dwAvailPhys div 1024;
      2 : r := dwTotalPageFile div 1024;
      3 : r := dwAvailPageFile div 1024;
      4 : r := dwTotalVirtual div 1024;
      5 : r := dwAvailVirtual div 1024;
      6 : r := dwMemoryLoad;
    end;
  result:=inttostr(r);
end;

function GetSystem(i:byte):String;
var j:longint;
begin
  Result:='(unavailable)';
  with TRegistry.create do begin
   try
    RootKey := HKEY_LOCAL_MACHINE;
    LazyWrite := false;
    OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion', False);
    case i of
     0: if ReadString('ProductName')<>'' then   result := ReadString('ProductName');
     1: if ReadString('ProductType')<>'' then   result := ReadString('ProductType');
     2: if ReadString('ProductId')<>'' then     result := ReadString('ProductId');
     3: if ReadString('ProductKey')<>'' then    result := ReadString('ProductKey');
     4: if ReadString('Version')<>'' then       result := ReadString('Version');
     5: if ReadString('VersionNumber')<>'' then result := ReadString('VersionNumber');
     6:  begin
          j := GetTickCount; // AW - 12/07/1999
          result := (IntToStr(j div (60 * 60 * 1000)) + ' Stunde(n) und ' + IntToStr((j div (60 * 1000)) - (j div (60 * 60 * 1000)) * 60) + ' Minute(n)'); // AW - 12/07/1999
         end;
     7: if isNT then result:='Windows NT' else result:='Windows 9x';
    end;
    CloseKey;
   Finally
   end;
  end;
end;


procedure TfrmAbout.btnOKClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmAbout.OpenObject(sObjectPath : PChar);
begin
 ShellExecute(0, PChar('Open'), sObjectPath, Nil, Nil, SW_NORMAL);
end;

procedure TfrmAbout.lblUrlClick(Sender: TObject);
  var TempString : array[0..79] of char;
begin
   StrPCopy(TempString,(sender as tlabel).Caption);
   OpenObject(TempString);
end;

procedure TfrmAbout.lblAuthorEmailClick(Sender: TObject);
  var TempString : array[0..79] of char;
begin
   StrPCopy(TempString,lblAuthorEmail.Caption);
   OpenObject(TempString);
end;

procedure TfrmAbout.lblHyper64Click(Sender: TObject);
  var TempString : array[0..79] of char;
begin
   StrPCopy(TempString,(sender as tlabel).Caption);
   OpenObject(TempString);
end;

procedure TfrmAbout.Timer1Timer(Sender: TObject);
begin
  if (ScrollBox.Top <= -184) then
    ScrollBox.Top := 184
  else
    ScrollBox.Top := ScrollBox.Top - 1;
end;

procedure TfrmAbout.FormShow(Sender: TObject);
begin
  ScrollBox.Top := Scrollbox.height;
  timer1.enabled:=true;
end;

procedure TfrmAbout.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 timer1.enabled:=false;
end;

procedure TfrmAbout.FormCreate(Sender: TObject);
begin
 lblsysinfo.caption:=GetCPU(1)+#13#13+
                     'Vendor: '+GetCPU(2)+#13+
                     'Speed: '+GetCPU(3)+#13+
                     'Processors: '+getCPU(4)+#13+
                     'Free Memory: '+getmemoryStatus(0)+#13#13+
                     'OS: '+GetSystem(7);
end;

end.
